#pragma once

#include "..\common\common.h"
#include "..\common\tile.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
/// \brief Tile ϴ XML о̰  tile   踦 мѴ.
//////////////////////////////////////////////////////////////////////////////////////////////////
class CTileContainer
{
	friend class CTileArranger;
	friend class CKeyLockComposer;
	friend class CCelledMapGenerator;
public:
	void	Reset();

	/** 
	* \brief Tile Set XML  оδ.
	*/
	int		ReadXML(string fullpath);

	int		GetTileCount() { return m_tilecount; }
	int		GetTileWidth() { return m_tileWidth; }
	int		GetTileHeight() { return m_tileHeight; }
private:
	int		GetIndexForCon(bool bNorth, bool bWest, bool bEast, bool bSouth);

	/** 
	* \brief Tile  cell matrix  Ա   踦 ľѴ.
	*/
	void	AnalyzeTile(int index);
	void	GetGate(Direction::Type dir, int *x, int *y);
	void	ADFS(int x, int y);
private:
	int				m_tilecount;
	vector<Tile>	m_tiles;

	/** 
	* \brief tile   Ǿ  ̸ ε .( Ա Ÿ  )
	*/
	vector<int>		m_listsForCon[16];

	/** 
	* \brief tile   Ǿ  ̸ ε .( Ա Ÿ   ȵǾ ־ )
	*/
	vector<int>		m_listsForConNoCross[16];
	int				m_tileWidth;
	int				m_tileHeight;
	int				m_matrixForCrossCheck[MAX_TILE_SIZE][MAX_TILE_SIZE];
};
