#pragma once

#include "common.h"

const TCHAR * const LEVGEN_TILESET_TAG_TILEDEF		= _T("TileDefinition");
const TCHAR * const LEVGEN_TILESET_TAG_TILE			= _T("Tile");
const TCHAR * const LEVGEN_TILESET_TAG_SOKOBANABLE	= _T("Sokobanable");
const TCHAR * const LEVGEN_TILESET_TAG_IMAGENAME	= _T("ImageName");
const TCHAR * const LEVGEN_TILESET_TAG_TYPEMATRIX	= _T("TypeMatrix");
const TCHAR * const LEVGEN_TILESET_TAG_SOKOBANMATRIX= _T("SokobanMatrix");

const TCHAR * const LEVGEN_TILESET_ATTR_ID			= _T("id");
const TCHAR * const LEVGEN_TILESET_ATTR_WIDTH		= _T("width");
const TCHAR * const LEVGEN_TILESET_ATTR_HEIGHT		= _T("height");
const TCHAR * const LEVGEN_TILESET_ATTR_IS			= _T("is");

struct Tile
{
	int				height;
	int				width;
	bool			isConnected[Direction::End];
	string			imageName;
	string			id;
	int				typeMatrix[MAX_TILE_SIZE][MAX_TILE_SIZE];
	bool			isSokobanable;
	vector<Coor>	sokobanBlocks;
};

