#pragma once
#include "common.h"

const TCHAR * const LEVGEN_RESULT_LEVEL_DEFINITION	= _T("LevelDefinition");
const TCHAR * const LEVGEN_RESULT_TILEALLOCATION 	= _T("TileAllocation");
const TCHAR * const LEVGEN_RESULT_LOCKKEYALLOCATION	= _T("LockKeyAllocation");
const TCHAR * const LEVGEN_RESULT_MONSTERALLOCATION	= _T("MonsterAllocation");
const TCHAR * const LEVGEN_RESULT_LOCK				= _T("Lock");
const TCHAR * const LEVGEN_RESULT_KEY				= _T("Key");
const TCHAR * const LEVGEN_RESULT_SOKOBAN			= _T("Sokoban");
const TCHAR * const LEVGEN_RESULT_BLOCK				= _T("Block");
const TCHAR * const LEVGEN_RESULT_CDATA				= _T("CDATA");
const TCHAR * const LEVGEN_RESULT_SOLUTIONPATH		= _T("SolutionPath");
const TCHAR * const LEVGEN_RESULT_ACTION			= _T("Action");
const TCHAR * const LEVGEN_RESULT_MONSTER			= _T("Monster");

const TCHAR * const LEVGEN_RESULT_ATTR_WIDTH		= _T("width");
const TCHAR * const LEVGEN_RESULT_ATTR_HEIGHT		= _T("height");
const TCHAR * const LEVGEN_RESULT_ATTR_TILESETPATH	= _T("tilesetpath");
const TCHAR * const LEVGEN_RESULT_ATTR_DIRECTION	= _T("Direction");
const TCHAR * const LEVGEN_RESULT_ATTR_X1			= _T("x1");
const TCHAR * const LEVGEN_RESULT_ATTR_X2			= _T("x2");
const TCHAR * const LEVGEN_RESULT_ATTR_Y1			= _T("y1");
const TCHAR * const LEVGEN_RESULT_ATTR_Y2			= _T("y2");
const TCHAR * const LEVGEN_RESULT_ATTR_X			= _T("x");
const TCHAR * const LEVGEN_RESULT_ATTR_Y			= _T("y");
const TCHAR * const LEVGEN_RESULT_ATTR_STARTX		= _T("startx");
const TCHAR * const LEVGEN_RESULT_ATTR_STARTY		= _T("starty");
const TCHAR * const LEVGEN_RESULT_ATTR_GOALX		= _T("goalx");
const TCHAR * const LEVGEN_RESULT_ATTR_GOALY		= _T("goaly");
const TCHAR * const LEVGEN_RESULT_ATTR_TYPE			= _T("type");
const TCHAR * const LEVGEN_RESULT_ATTR_EXP			= _T("exp");
const TCHAR * const LEVGEN_RESULT_ATTR_ID			= _T("id");

const TCHAR * const LEVGEN_RESULT_ATTR_V_MOVE		= _T("Move");
const TCHAR * const LEVGEN_RESULT_ATTR_V_GETKEY		= _T("GetKey");
const TCHAR * const LEVGEN_RESULT_ATTR_V_UNLOCK		= _T("UnLock");
const TCHAR * const LEVGEN_RESULT_ATTR_V_SOLVESOKOBAN	= _T("SolveSokoban");
const TCHAR * const LEVGEN_RESULT_ATTR_V_KILLMONSTER	= _T("KillMonster");

const TCHAR * const STRACTIONTYPE[6] = {"None", "Move", "GetKey", "UnLock", "SolveSokoban", "KillMonster"};


