#pragma once
#include "common.h"

const TCHAR * const LEVGEN_UNIT_DEFINITION			= _T("UnitDefinition");
const TCHAR * const LEVGEN_UNIT_HERO				= _T("Hero");
const TCHAR * const LEVGEN_UNIT_IMAGE				= _T("Image");
const TCHAR * const LEVGEN_UNIT_MONSTER				= _T("Monster");

const TCHAR * const LEVGEN_UNIT_ATTR_PATH			= _T("path");
const TCHAR * const LEVGEN_UNIT_ATTR_DIRECTION		= _T("direction");
const TCHAR * const LEVGEN_UNIT_ATTR_ID				= _T("id");
const TCHAR * const LEVGEN_UNIT_ATTR_LEVEL			= _T("level");
const TCHAR * const LEVGEN_UNIT_ATTR_EXP			= _T("exp");
const TCHAR * const LEVGEN_UNIT_ATTR_IMAGEPATH		= _T("imagepath");

struct Units
{
	struct Monster
	{
		string		id;
		int			level;
		int			exp;
		string		imagePath;
	};

	string heroImagePath[NDIRECTION];
	vector<Monster> monsters;
};

bool MonsterCompare(const Units::Monster& m1, const Units::Monster& m2);

int ParseMonsterXML(string path, Units *units);


